# perl vyberacro.pl < soubor.txt > vystup.txt 
# ------------------------------------------- 
# prikaz "perl vyberacro.pl < soubor.txt" kopiruje radky ze souboru 
# soubor.txt na standartni vystup a radky, ktere zacinaji po sobe 
# a zacinaji znakem
# "-" nahodne prohazi s radkem ktery zacina na "+", posledni text
# nahradi textem "jina odpoved". Skript take pridava prikazy aby se to
# dalo pouzit v acrotexu.

# nastaveni parametru
$variantspatne=4;
$pocetzadani=6;

# nacteme hlavicku
open(HLAVA,"lim-a.hlavicka");
@pole=<HLAVA>;
print @pole;

@pole=<STDIN>;
push(@pole,"konec");
@spatne=();
@spatnevyber=();
@spatneperm=();
$spravne="";
$bylominus=0;
$pocetspatne=0;
$celkemzadani=0;
@ktisku=();
$radekvystup="";

#### spocita pocet zadani (kazde ma jednu spravnou odpoved)
foreach $radek (@pole)
{
    if (substr($radek,0,1) eq "+") {$celkemzadani++;}
}

@temp=0;

foreach $radek (@pole)
{
    chomp($radek);
    # radek nezacina plusem ani minusem
    if (not(substr($radek,0,1) eq "-") and not(substr($radek,0,1) eq "+")) 
    {
	if ($bylominus==1) 
	{
	    @spatnevyber=();
	    # nahodne vybereme spatne odpovedi
	    for ($cislo=($pocetspatne-1);$cislo>=($pocetspatne-$variantspatne);$cislo--)
	    {
		$randcislo = int(rand($cislo+1));
		push(@spatnevyber,$spatne[$randcislo]);
		splice(@spatne,$randcislo,1);
	    }
	    # pridame spravnou odpoved
	    push(@spatnevyber,$spravne);
	    # promichame
	    for ($cislo=$variantspatne;$cislo>=0;$cislo--)
	    {
		$randcislo = int(rand($cislo+1));
		push(@spatneperm,$spatnevyber[$randcislo]);
		splice(@spatnevyber,$randcislo,1);
	    }
	    # zmenime zneni posledni odpovedi, spravnost nechame
	    $plusminus=substr($spatneperm[$variantspatne],0,1);
	    $spatneperm[$variantspatne]=$plusminus."jin odpov";
	    $cislo=0;
	    # zmenime tak, aby to proslo v AcroTeXu
	    for ($cislo=0; $cislo<=($variantspatne); $cislo++)
	    {
		$odpoved=$spatneperm[$cislo];
		$odpoved=~ s/^\+/\\Ans1 /;
		$odpoved=~ s/^-/\\Ans0 /;
		if (not($cislo==$variantspatne))
		{
		    chomp $odpoved;
		    $radekvystup=$radekvystup.$odpoved."\\\\[5pt]\n";
		}
		else
		{
		    $radekvystup=$radekvystup.$odpoved."\n\\end{answers}\n\n\n";
		}
	    }
	    # pokud to zadani mame tisknout, tak ho vytiskneme
	    push (@ktisku,$radekvystup);
	    # nova inicializace promennych pro dalsi zadani
	    $radekvystup="";
	    $pocetspatne=0;
	    $spravne="";
	    @spatne=();
	    @spatneperm=();
	    $bylominus=0;
	}
	if ($radek eq "")
	{
	    $radekvystup=$radekvystup.$radek;
	}
	else
	{
	    $radekvystup=$radekvystup."\\zadani{".$radek."}\n\\begin{answers}{1}\n";
	}
    }
    else
    {
	if (substr($radek,0,1) eq "-")
	{
	    $bylominus=1;
	    $pocetspatne=$pocetspatne+1;
	    push(@spatne,$radek."\n");
	}
	else
	{
	    $spravne=$radek."\n";
	}
    }
}


for ($cislo=$celkemzadani;$cislo>($celkemzadani-$pocetzadani);$cislo--)
{
    $randcislo = int(rand($cislo));
    print $ktisku[$randcislo];
    splice(@ktisku,$randcislo,1);
}




#nacteme paticku
open(HLAVA,"lim-a.paticka");
@pole=<HLAVA>;
print @pole;

