
@ktisku=();


#### Procedura cte radky souboru jehoz nazev je  v prvnim parametru
#### a zpracovava je pro dalsi pouziti. V druhem parametruje pocet spatnych
#### moznosti.
#### Vystupem jsou otazky, ve kterych jsou nahodne prehazeny moznosti a 
#### uvodni + a - jsou nahrazena prikazy \Ans0 a \Ans1
sub filtruj{
    my ($jmenosouboru,$variantspatne)=@_;
    open(HLAVA,$jmenosouboru);
    my @predfiltrem=<HLAVA>;
    push(@predfiltrem,"konec");
    my @pofiltru=();
    my @spatne=();
    my @spatnevyber=();
    my @spatneperm=();
    my $spravne="";
    my $bylominus=0;
    my $pocetspatne=0;
    my $radekvystup="";
    foreach $radek (@predfiltrem)
    {
	chomp($radek);
	# radek nezacina plusem ani minusem
	if (not(substr($radek,0,1) eq "-") and not(substr($radek,0,1) eq "+")) 
	{
	    if ($bylominus==1) 
	    {
		@spatnevyber=();
		# nahodne vybereme spatne odpovedi
		for ($cislo=($pocetspatne-1);$cislo>=($pocetspatne-$variantspatne);$cislo--)
		{
		    $randcislo = int(rand($cislo+1));
		    push(@spatnevyber,$spatne[$randcislo]);
		    splice(@spatne,$randcislo,1);
		}
		# pridame spravnou odpoved
		push(@spatnevyber,$spravne);
		# promichame
		for ($cislo=$variantspatne;$cislo>=0;$cislo--)
		{
		    $randcislo = int(rand($cislo+1));
		    push(@spatneperm,$spatnevyber[$randcislo]);
		    splice(@spatnevyber,$randcislo,1);
		}
		# zmenime zneni posledni odpovedi, spravnost nechame
# 	    $plusminus=substr($spatneperm[$variantspatne],0,1);
# 	    $spatneperm[$variantspatne]=$plusminus."jin odpov";
		$cislo=0;
		# zmenime tak, aby to proslo v AcroTeXu
		for ($cislo=0; $cislo<=($variantspatne); $cislo++)
		{
		    $odpoved=$spatneperm[$cislo];
		    $odpoved=~ s/^\+/\\Ans1 /;
		    $odpoved=~ s/^-/\\Ans0 /;
		    if (not($cislo==$variantspatne))
		    {
			chomp $odpoved;
			$radekvystup=$radekvystup.$odpoved."\\\\[5pt]\n";
		    }
		    else
		    {
			$radekvystup=$radekvystup.$odpoved."\\end{answers}\n\n\n";
		    }
		}
		# pokud to zadani mame tisknout, tak ho vytiskneme
		push (@pofiltru,$radekvystup);
		# nova inicializace promennych pro dalsi zadani
		$radekvystup="";
		$pocetspatne=0;
		$spravne="";
		@spatne=();
		@spatneperm=();
		$bylominus=0;
	    }
	    if ($radek eq "")
	    {
		$radekvystup=$radekvystup.$radek;
	    }
	    else
	    {
		$radekvystup=$radekvystup."\\zadani{".$radek."}\n\\begin{answers}{1}\n";
	    }
	}
	else
	{
	    if (substr($radek,0,1) eq "-")
	    {
		$bylominus=1;
		$pocetspatne=$pocetspatne+1;
		push(@spatne,$radek."\n");
	    }
	    else
	    {
		$spravne=$radek."\n";
	    }
	}
    }
return(@pofiltru)
}






######## vlastni program
# nacteme a vytiskneme hlavicku
open(HLAVA,"teorie.hlavicka");
@pole=<HLAVA>;
print @pole;

sub generujnahodne
# parametry udavaji jmeno souboru, kolik vybrat otazek a kolik 
# zahrnout spatnych odpovedi.
{
    my ($jmeno,$pocetzadani,$variantspatne)=@_;
    my @hotovezadani;
    my @ktisku;

# nacteme otazky a prislusny pocet odpovedi, odpovedi uz budou prehazene
    @ktisku=filtruj($jmeno,$variantspatne);
    
# Vybereme nahodne 
    my $celkemzadani=@ktisku;
    for ($cislo=$celkemzadani;$cislo>($celkemzadani-$pocetzadani);$cislo--)
    {
	$randcislo = int(rand($cislo));
	push(@hotovezadani, $ktisku[$randcislo]);
	splice(@ktisku,$randcislo,1);
    }
    return @hotovezadani;
}


print generujnahodne("teorie1.txt",4,4);
print generujnahodne("teorie2.txt",4,4);
print generujnahodne("teorie3.txt",2,4);
print generujnahodne("teorie4.txt",2,4);
 
#nacteme paticku
open(HLAVA,"teorie.paticka");
@polekonec=<HLAVA>;
print @polekonec;


