# 
#
# Vstup:
# $y''-4y=4xe^{2x}$
# +{x(2x-1)exp(2x)/4}{e^(2x)}{e^(-2x)}
# -[x(ax+b)e^{2x}]

# $y''+3y'-4y=0$
# +{x(2x-1)exp(2x)/4}{e^(2x)}{e^(-2x)}
# -x(ax+b)e^{2x}




# Vystup:
# \zadani[x(ax+b)e^{2x}]{$y''-4y=4xe^{2x}$}
# \reseni{x(2x-1)exp(2x)/4}{e^(2x)}{e^(-2x)}

# \zadani{$y''+3y'-4y=0$}
# \reseni{0}{exp(-4x)}{exp(x)}




# nastaveni parametru
$pocetzadanih=3; # pocet homogennich rovnic
$pocetzadanin=3; # pocet nehomogennich rovnic
$pocetzadani=$pocetzadanih+$pocetzadanin;

# nacteme hlavicku
open(HLAVA,"ldr2-a.hlavicka");
@pole=<HLAVA>;
print @pole;

@pole=<STDIN>;
push(@pole,"konec");
@spatne=();
@spatnevyber=();
@spatneperm=();
$spravne="";
$bylominus=0;
$prvniznak="";
$celkemzadani=0;
$celkemzadanih=0;
$celkemzadanin=0;
$zadani="";
@ktisku=();
@ktiskufinal=();
@ktiskun=(); # nehomogenni
@ktiskuh=(); # homogenni
$radekvystup="";

#### spocita pocet zadani (kazde ma jednu spravnou odpoved)
foreach $radek (@pole)
{
    if (substr($radek,0,1) eq "+") {$celkemzadani++;}
}

@temp=0;

foreach $radek (@pole)
{
    chomp($radek);
    # radek nezacina plusem ani minusem
    if (not(substr($radek,0,1) eq "-") and not(substr($radek,0,1) eq "+")) 
    {
	if ($bylominus==1) 
	{
	    chomp($spravne);
	    chomp($spatne[0]);
	    $spravne=~ s/^\+//;
	    $spatne[0]=~ s/^-//;
	    if ($spatne[0] eq "")
	    {
		$radekvystup="\\zadani{$zadani}\n\\reseni$spravne\n\n";
		push (@ktiskuh,$radekvystup);
	    }
	    else
	    {
		$radekvystup="\\zadani[$spatne[0]]{$zadani}\n\\reseni$spravne\n\n";
		push (@ktiskun,$radekvystup);
	    }
	    # nova inicializace promennych pro dalsi zadani
	    $radekvystup="";
	    $spravne="";
	    @spatne=();
	    $bylominus=0;
	    $zadani="";
	}
	if (not ($radek eq ""))
	{
	    $zadani=$radek;
	}
    }
    else
    {
	if (substr($radek,0,1) eq "-")
	{
	    $bylominus=1;
	    $pocetspatne=$pocetspatne+1;
	    push(@spatne,$radek."\n");
	}
	else
	{
	    $spravne=$radek."\n";
	}
    }
}


$celkemzadanin=@ktiskun;
for ($cislo=$celkemzadanin;$cislo>($celkemzadanin-$pocetzadanin);$cislo--)
{
    $randcislo = int(rand($cislo));
    push(@ktisku,$ktiskun[$randcislo]);
    splice(@ktiskun,$randcislo,1);
}

$celkemzadanih=@ktiskuh;
for ($cislo=$celkemzadanih;$cislo>($celkemzadanih-$pocetzadanih);$cislo--)
{
    $randcislo = int(rand($cislo));
    push(@ktisku,$ktiskuh[$randcislo]);
    splice(@ktiskuh,$randcislo,1);
}

$celkemzadani=@ktisku;
for ($cislo=$celkemzadani;$cislo>($celkemzadani-$pocetzadani);$cislo--)
{
    $randcislo = int(rand($cislo));
    push(@ktiskufinal,$ktisku[$randcislo]);
    splice(@ktisku,$randcislo,1);
}

print @ktiskufinal;




#nacteme paticku
open(HLAVA,"ldr2-a.paticka");
@pole=<HLAVA>;
print @pole;

