# perl vyberacro.pl < soubor.txt > vystup.txt 
# ------------------------------------------- 
# prikaz "perl vyberacro.pl < soubor.txt" kopiruje radky ze souboru 
# soubor.txt na standartni vystup a radky, ktere zacinaji po sobe 
# a zacinaji znakem
# "-" nahodne prohazi s radkem ktery zacina na "+", posledni text
# nahradi textem "jina odpoved". Skript take pridava prikazy aby se to
# dalo pouzit v acrotexu.

# nastaveni parametru
$variantspatne=4;
$pocetzadani=6;


open(HLAVA,"lim-a.hlavicka");
@pole=<HLAVA>;
print @pole;

@pole=<STDIN>;
@spatne=();
@spatnevyber=();
@spatneperm=();
$spravne="";
$bylominus=0;
$pocetspatne=0;
$celkemzadani=0;
$temp=0;
@ktisku=();
$vytistenozadani=0;
$aktualnizadani=0;

#### spocita pocet zadani (kazde ma jednu spravnou odpoved)
foreach $radek (@pole)
{
    if (substr($radek,0,1) eq "+") {$celkemzadani++;}
}

#### nahodna cisla
my @temppole;
my $indexx;
my @pole_hodnot=();
my $tip;
$pocet=$celkemzadani;
for ($indexx=1;$indexx<=$pocet;$indexx++)
{
    push(@temppole,$indexx);
}
for ($indexx=$pocet;$indexx>0;$indexx--)
{
    $tip=int(rand($indexx));
    $temp++;
    if ($temp<=$pocetzadani)
    {
	push(@pole_hodnot,$temppole[$tip].",");
    }
    splice(@temppole,$tip,1);
}


#print @pole_hodnot,"\n";
@setr_pole_hodnot = sort {$a <=> $b} @pole_hodnot;
#print @setr_pole_hodnot,"\n";

@temp=0;

foreach $radek (@pole)
{
    chomp($radek);
    # radek nezacina plusem ani minusem
    if (not(substr($radek,0,1) eq "-") and not(substr($radek,0,1) eq "+")) 
    {
	if ($bylominus==1) 
	{
	    @spatnevyber=();
	    $celkemzadani++;
	    # nahodne vybereme spatne odpovedi
	    for ($cislo=($pocetspatne-1);$cislo>=($pocetspatne-$variantspatne);$cislo--)
	    {
		$randcislo = int(rand($cislo+1));
		push(@spatnevyber,$spatne[$randcislo]);
		splice(@spatne,$randcislo,1);
	    }
	    # pridame spravnou odpoved
	    push(@spatnevyber,$spravne);
	    # promichame
	    for ($cislo=$variantspatne;$cislo>=0;$cislo--)
	    {
		$randcislo = int(rand($cislo+1));
		push(@spatneperm,$spatnevyber[$randcislo]);
		splice(@spatnevyber,$randcislo,1);
	    }
	    # zmenime zneni posledni odpovedi, spravnost nechame
	    $plusminus=substr($spatneperm[$variantspatne],0,1);
	    $spatneperm[$variantspatne]=$plusminus."jin odpov";
	    $cislo=0;
	    # zmenime tak, aby to proslo vo AcroTeXu
	    for ($cislo=0; $cislo<=($variantspatne); $cislo++)
	    {
		$odpoved=$spatneperm[$cislo];
		$odpoved=~ s/^\+/\\Ans1 /;
		$odpoved=~ s/^-/\\Ans0 /;
		if (not($cislo==$variantspatne))
		{
		    chomp $odpoved;
		    push(@ktisku,$odpoved."\\\\\n");
		}
		else
		{
		    push(@ktisku,$odpoved."\n\\end{answers}\n");
		}
	    }
	    $aktualnizadani++;
	    # pokud to zadani mame tisknout, tak ho vytiskneme
	    if ($vytistenozadani<$pocetzadani)
	    {		
		if ($aktualnizadani==$setr_pole_hodnot[0])
		{
		    print @ktisku;
		    shift(@setr_pole_hodnot);
		    $vytistenozadani++;
		}
	    }
	    # nova inicializace promennych pro dalsi zadani
	    @ktisku=();
	    $pocetspatne=0;
	    $spravne="";
	    @spatne=();
	    @spatneperm=();
	    $bylominus=0;
	    print "\n\n";
	}
	if ($radek eq "")
	{
	    push(@ktisku,$radek);
	}
	else
	{
	    push(@ktisku,"\\zadani{".$radek."}\n\\begin{answers}{1}\n");
	}
    }
    else
    {
	if (substr($radek,0,1) eq "-")
	{
	    $bylominus=1;
	    $pocetspatne=$pocetspatne+1;
	    $radek=$radek."\n";
	    push(@spatne,$radek);
	}
	else
	{
	    $radek=$radek."\n";
	    $spravne=$radek;
	}
    }
}

open(HLAVA,"lim-a.paticka");
@pole=<HLAVA>;
print @pole;

